<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:07 +0000">

<link rel="stylesheet" type="text/css" href="../../../stylesheet.css">
<link rel="start" href="../../../overview-summary.html">

<title>doclets/debug/debug.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../../overview-files.html">Files</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../todo-list.html">Todo</a></li>
<li><a href="../../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../../index.html" target="_top">Frames</a>
<a href="../../../source/doclets/debug/debug.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>doclets/debug/debug.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2004 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** The debugging doclet. This doclet outputs all the parsed data in a format
<a name="line22"></a> * suitable for debugging PHPDoctor.
<a name="line23"></a> *
<a name="line24"></a> * @package PHPDoctor\Doclets\Debug
<a name="line25"></a> */
<a name="line26"></a>class Debug extends Doclet
<a name="line27"></a>{
<a name="line28"></a>
<a name="line29"></a>	/** The depth of processing through the element hierarchy.
<a name="line30"></a>	 *
<a name="line31"></a>	 * @var int
<a name="line32"></a>	 */
<a name="line33"></a>	var $depth = 0;
<a name="line34"></a>
<a name="line35"></a>	/** Doclet constructor.
<a name="line36"></a>	 *
<a name="line37"></a>	 * @param RootDoc rootDoc
<a name="line38"></a>	 * @param TextFormatter formatter
<a name="line39"></a>	 */
<a name="line40"></a>	function debug(&$rootDoc, $formatter)
<a name="line41"></a>    {
<a name="line42"></a>        
<a name="line43"></a>		$this->formatter = $formatter;
<a name="line44"></a>		
<a name="line45"></a>		foreach ($rootDoc->packages() as $package) {
<a name="line46"></a>			echo '- Namespace ', $package->name(), "\n";
<a name="line47"></a>			$this->fieldDoc($package->globals());
<a name="line48"></a>			$this->methodDoc($package->functions());
<a name="line49"></a>			$this->classDoc($package->allClasses());
<a name="line50"></a>
<a name="line51"></a>		}
<a name="line52"></a>		
<a name="line53"></a>		echo "Done\n";
<a name="line54"></a>	
<a name="line55"></a>	}
<a name="line56"></a>    
<a name="line57"></a>    /** Return the depth indicator string
<a name="line58"></a>     *
<a name="line59"></a>     * @return str
<a name="line60"></a>     */
<a name="line61"></a>    function showDepth()
<a name="line62"></a>    {
<a name="line63"></a>        return str_repeat('|', $this->depth);
<a name="line64"></a>    }
<a name="line65"></a>
<a name="line66"></a>	/** Output fieldDoc
<a name="line67"></a>	 *
<a name="line68"></a>	 * @param FieldDoc[] fields
<a name="line69"></a>	 */
<a name="line70"></a>	function fieldDoc(&$fields, $showAccess = FALSE)
<a name="line71"></a>    {
<a name="line72"></a>		$this->depth++;
<a name="line73"></a>		if ($fields) {
<a name="line74"></a>			foreach ($fields as $field) {
<a name="line75"></a>				$type = $field->type();
<a name="line76"></a>				echo $this->showDepth(), '- ', $field->modifiers($showAccess), $type->toString(), ' ';
<a name="line77"></a>				if ($field->isFinal()) {
<a name="line78"></a>					echo $field->packageName(), '\\', $field->name();
<a name="line79"></a>				} else {
<a name="line80"></a>					echo $field->packageName(), '\\$', $field->name();
<a name="line81"></a>				}
<a name="line82"></a>				if ($field->value()) {
<a name="line83"></a>					echo ' = ', $field->value();
<a name="line84"></a>				}
<a name="line85"></a>				echo ' [', $field->location(), ']';
<a name="line86"></a>				echo "\n";
<a name="line87"></a>				$this->docComment($field);
<a name="line88"></a>			}
<a name="line89"></a>		}
<a name="line90"></a>		$this->depth--;
<a name="line91"></a>	}
<a name="line92"></a>	
<a name="line93"></a>	/** Output methodDoc
<a name="line94"></a>	 *
<a name="line95"></a>	 * @param MethodDoc[] methods
<a name="line96"></a>	 */
<a name="line97"></a>	function methodDoc(&$methods)
<a name="line98"></a>    {
<a name="line99"></a>		$this->depth++;
<a name="line100"></a>		if ($methods) {
<a name="line101"></a>			foreach ($methods as $method) {
<a name="line102"></a>				$type = $method->returnType();
<a name="line103"></a>				echo $this->showDepth(), '- ', $method->modifiers();
<a name="line104"></a>				if ($type) {
<a name="line105"></a>					echo $type->toString(), ' ';
<a name="line106"></a>				} else {
<a name="line107"></a>					echo 'void ';
<a name="line108"></a>				}
<a name="line109"></a>				echo $method->packageName(), '\\', $method->name(), $method->flatSignature();
<a name="line110"></a>				echo ' [', $method->location(), ']';
<a name="line111"></a>				echo "\n";
<a name="line112"></a>				$this->fieldDoc($method->parameters());
<a name="line113"></a>				$this->methodDoc($method->functions());
<a name="line114"></a>				$exceptions =& $method->thrownExceptions();
<a name="line115"></a>				if ($exceptions) {
<a name="line116"></a>					foreach ($exceptions as $exception) {
<a name="line117"></a>						echo $this->showDepth(), '|- throws ';
<a name="line118"></a>						if (is_object($exception)) {
<a name="line119"></a>							echo $exception->packageName(), '\\', $exception->name(), "\n";
<a name="line120"></a>						} else {
<a name="line121"></a>							echo $exception, "\n";
<a name="line122"></a>						}
<a name="line123"></a>					}
<a name="line124"></a>				}
<a name="line125"></a>				$this->docComment($method);
<a name="line126"></a>			}
<a name="line127"></a>		}
<a name="line128"></a>		$this->depth--;
<a name="line129"></a>	}
<a name="line130"></a>	
<a name="line131"></a>	/** Output constructorDoc
<a name="line132"></a>	 *
<a name="line133"></a>	 * @param ConstructorDoc constructor
<a name="line134"></a>	 */
<a name="line135"></a>	function constructorDoc(&$constructor)
<a name="line136"></a>    {
<a name="line137"></a>		$this->depth++;
<a name="line138"></a>		if ($constructor) {
<a name="line139"></a>            echo $this->showDepth(), '- ', $constructor->modifiers();
<a name="line140"></a>            echo $constructor->packageName(), '\\', $constructor->name(), $constructor->flatSignature();
<a name="line141"></a>            echo ' [', $constructor->location(), ']';
<a name="line142"></a>            echo "\n";
<a name="line143"></a>            $this->fieldDoc($constructor->parameters());
<a name="line144"></a>		}
<a name="line145"></a>		$this->depth--;
<a name="line146"></a>	}
<a name="line147"></a>
<a name="line148"></a>	/** Output classDoc
<a name="line149"></a>	 *
<a name="line150"></a>	 * @param ClassDoc[] classes
<a name="line151"></a>	 */
<a name="line152"></a>	function classDoc(&$classes)
<a name="line153"></a>    {
<a name="line154"></a>		$this->depth++;
<a name="line155"></a>		if ($classes) {
<a name="line156"></a>			foreach ($classes as $class) {
<a name="line157"></a>				echo $this->showDepth(), '- ', $class->modifiers();
<a name="line158"></a>				if ($class->isInterface()) {
<a name="line159"></a>					echo 'interface ';
<a name="line160"></a>				} else {
<a name="line161"></a>					echo 'class ';
<a name="line162"></a>				}
<a name="line163"></a>				echo $class->packageName(), '\\', $class->name();
<a name="line164"></a>				if ($class->superclass()) {
<a name="line165"></a>				    if (isset($classes[$class->superclass()])) {
<a name="line166"></a>				        $superclass = $classes[$class->superclass()];
<a name="line167"></a>				        echo ' extends ', $superclass->packageName(), '\\', $superclass->name();
<a name="line168"></a>				    } else {
<a name="line169"></a>				        echo ' extends ', $class->superclass();
<a name="line170"></a>				    }
<a name="line171"></a>				}
<a name="line172"></a>				$interfaces =& $class->interfaces();
<a name="line173"></a>				if ($interfaces) {
<a name="line174"></a>					echo ' implements ';
<a name="line175"></a>					foreach($interfaces as $interface) {
<a name="line176"></a>						echo $interface->packageName(), '\\', $interface->name(), ' ';
<a name="line177"></a>					}
<a name="line178"></a>				}
<a name="line179"></a>				echo ' [', $class->location(), ']';
<a name="line180"></a>				echo "\n";
<a name="line181"></a>				$this->docComment($class);
<a name="line182"></a>				$this->fieldDoc($class->constants(), TRUE);
<a name="line183"></a>				$this->fieldDoc($class->fields(), TRUE);
<a name="line184"></a>				$this->methodDoc($class->methods());
<a name="line185"></a>			}
<a name="line186"></a>		}
<a name="line187"></a>		$this->depth--;
<a name="line188"></a>	}
<a name="line189"></a>	
<a name="line190"></a>	function docComment(&$programElement) {
<a name="line191"></a>	    $textTag =& $programElement->tags('@text');
<a name="line192"></a>        if ($textTag && $textTag->text($this)) {
<a name="line193"></a>            echo $this->showDepth(), '|= ', $textTag->text($this), "\n";
<a name="line194"></a>            foreach($textTag->inlineTags($this) as $inlineTag) {
<a name="line195"></a>                if ($inlineTag->name() != '@text') {
<a name="line196"></a>                    echo $this->showDepth(), '|= ', $inlineTag->displayName(), ': ', $inlineTag->text($this), "\n";
<a name="line197"></a>                }
<a name="line198"></a>            }
<a name="line199"></a>        }
<a name="line200"></a>	}
<a name="line201"></a>	
<a name="line202"></a>}
<a name="line203"></a>
<a name="line204"></a>?>
<a name="line205"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../../overview-files.html">Files</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../todo-list.html">Todo</a></li>
<li><a href="../../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../../index.html" target="_top">Frames</a>
<a href="../../../source/doclets/debug/debug.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>